Minimum number of swaps required for arranging pairs adjacent to each other - GeeksforGeeks


Minimum number of swaps required for arranging pairs adjacent to each other - GeeksforGeeks
There are n-pairs and therefore 2n people. everyone has one unique number ranging from 1 to 2n. All these 2n persons are arranged in random fashion in an Array of size 2n. We are also given who is partner of whom. Find the minimum number of swaps required to arrange these pairs such that all pairs become adjacent to each other.
Example:
Input:
n = 3  
pairs[] = {1->3, 2->6, 4->5}  // 1 is partner of 3 and so on
arr[] = {3, 5, 6, 4, 1, 2}

Output: 2
We can get {3, 1, 5, 4, 6, 2} by swapping 5 & 6, and 6 & 1
1) If first and second elements are pair, then simply recur 
   for remaining n-1 pairs and return the value returned by 
   recursive call.

2) If first and second are NOT pair, then there are two ways to 
   arrange. So try both of them return the minimum of two.
   a) Swap second with pair of first and recur for n-1 elements. 
      Let the value returned by recursive call be 'a'.
   b) Revert the changes made by previous step.
   c) Swap first with pair of second and recur for n-1 elements. 
      Let the value returned by recursive call be 'b'.
   d) Revert the changes made by previous step before returning
      control to parent call.
   e) Return 1 + min(a, b)

// This function updates indexes of elements 'a' and 'b'
void updateindex(int index[], int a, int ai, int b, int bi)
{
    index[a] = ai;
    index[b] = bi;
}
// This function returns minimum number of swaps required to arrange
// all elements of arr[i..n] become aranged
int minSwapsUtil(int arr[], int pairs[], int index[], int i, int n)
{
    // If all pairs procesed so no swapping needed return 0
    if (i > n) return 0;
    // If current pair is valid so DO NOT DISTURB this pair
    // and move ahead.
    if (pairs[arr[i]] == arr[i+1])
         return minSwapsUtil(arr, pairs, index, i+2, n);
    // If we reach here, then arr[i] and arr[i+1] don't form a pair
    // Swap pair of arr[i] with arr[i+1] and recursively compute
    // minimum swap required if this move is made.
    int one = arr[i+1];
    int indextwo = i+1;
    int indexone = index[pairs[arr[i]]];
    int two = arr[index[pairs[arr[i]]]];
    swap(arr[i+1], arr[indexone]);
    updateindex(index, one, indexone, two, indextwo);
    int a = minSwapsUtil(arr, pairs, index, i+2, n);
    // Backtrack to previous configuration. Also restore the
    // previous indices, of one and two
    swap(arr[i+1], arr[indexone]);
    updateindex(index, one, indextwo, two, indexone);
    one = arr[i], indexone = index[pairs[arr[i+1]]];
    // Now swap arr[i] with pair of arr[i+1] and recursively
    // compute minimum swaps required for the subproblem
    // after this move
    two = arr[index[pairs[arr[i+1]]]], indextwo = i;
    swap(arr[i], arr[indexone]);
    updateindex(index, one, indexone, two, indextwo);
    int b = minSwapsUtil(arr, pairs, index, i+2, n);
    // Backtrack to previous configuration.  Also restore
    // the previous indices, of one and two
    swap(arr[i], arr[indexone]);
    updateindex(index, one, indextwo, two, indexone);
    // Return minimum of two cases
    return 1 + min(a, b);
}
// Returns minimum swaps required
int minSwaps(int n, int pairs[], int arr[])
{
    int index[2*n + 1]; // To store indices of array elements
    // Store index of each element in array index
    for (int i = 1; i <= 2*n; i++)
        index[arr[i]] = i;
    // Call the recursive function
    return minSwapsUtil(arr, pairs, index, 1, 2*n);
}
https://github.com/mission-peace/interview/blob/master/src/com/interview/recursion/SetPairTogether.java
Time complexity is O(2^n)
public int findMinimumSwaps(int input[], Map<Integer, Integer> pair) {
Map<Integer, Integer> index = new HashMap<>();
for (int i = 0; i < input.length; i++) {
index.put(input[i], i);
}
return findMinimumSwapsUtil(input, pair, index, 0);
}

public int findMinimumSwapsUtil(int input[], Map<Integer, Integer> pair, Map<Integer, Integer> index, int current) {
if (current == input.length) {
return 0;
}

int v1 = input[current];
int v2 = input[current + 1];
int pv2 = pair.get(v1);

if(pv2 == v2) {
return findMinimumSwapsUtil(input, pair, index, current + 2);
} else {
int idx1 = index.get(v1);
int idx2 = index.get(v2);

int idx3 = index.get(pair.get(v1));
int idx4 = index.get(pair.get(v2));

swap(index, input, idx2, idx3);
int val1 = findMinimumSwapsUtil(input, pair, index, current + 2);
swap(index, input, idx2, idx3);

swap(index, input, idx1, idx4);
int val2 = findMinimumSwapsUtil(input, pair, index, current + 2);
swap(index, input, idx1, idx4);

return 1 + Math.min(val1, val2);
}
}

private void swap(Map<Integer, Integer> index, int input[], int i, int j) {
index.compute(input[i], (k, v) -> j);
index.compute(input[j], (k, v) -> i);

int t = input[i];
input[i] = input[j];
input[j] = t;
}
https://discuss.leetcode.com/topic/113/minimum-number-of-swaps-required-for-arranging-pairs-adjacent-to-each-other
This looks like another DFS problem.
There are two choices for each recursion the two numbers are not a pair.
(1) swap the second one with the first number's pair, or
(2) swap the first one with the second number's pair.
To prevent from finding the number and their pairs from the array which costs O(2n), the indexes and pairs are stored using two HashMap. Therefore, after swapping the numbers, the index map needs to be adjusted as well.
 Map<Integer, Integer> pairs = new HashMap();
 Map<Integer, Integer> indexs = new HashMap();
 private void swap(int[] nums, int x, int y){
  int temp = nums[x];
  nums[x] = nums[y];
  nums[y] = temp;
 }
 private int DFS(int s, int len, int[] nums) {
  if ( s >= len ) return 0;
  int ret = Integer.MAX_VALUE;
  int num0 = nums[s], num1 = nums[s+1];
  int p0 = pairs.get(num0), p1 = pairs.get(num1);
  int p0_i = indexs.get(p0), p1_i = indexs.get(p1);
  if ( (num1 == p0) || (num0 == p1) ) return DFS(s+2, len, nums);
  swap(nums, s+1, p0_i);
  indexs.put(num1, p0_i);
  indexs.put(p0, s+1);
  ret = Math.min(ret, DFS(s+2, len, nums) );
  swap(nums, s+1, p0_i);
  indexs.put(num1, s+1);
  indexs.put(p0, p0_i);

  swap(nums, s, p1_i);
  indexs.put(num0, p1_i);
  indexs.put(p1, s);
  ret = Math.min(ret, DFS(s+2, len, nums) );
  swap(nums, s, p1_i);
  indexs.put(num0, s);
  indexs.put(p1, p1_i);
  return ret+1;
 }
 public int minSwapPairs(int[][] pars, int[] nums, int n ){
  if (pars == null || nums == null || pars.length == 0 
    || nums.length ==0 || n == 0) return 0;
  for (int[] par : pars) {
   pairs.put(par[0], par[1]);
   pairs.put(par[1], par[0]);
  }
  for (int i=0; i< (2*n); i++) {
   indexs.put(nums[i], i);
  }
  return DFS(0, 2*n, nums);
 }
TODO ------ not sure about its correctness

I think greedy can apply to this problem:
suppose the pairs are a1, a2b1, b2c1, c2, so on and so force. (We assume that the alphabetical character is numberless here, in our analysis abc is just enough)
  1. separate the position of arr[] into n groups
  2. take group one for example, there are two numbers inside:
    2.1 [a1, a2]. If the numbers inside are already a pair, skip to next group
    2.2 [a1, b1]. We just assume that a1 is at its correct position and we need to swap b1 and a2. (We can prove that, it is no matter that we assume a1 or b1 at its correct position.) Count this swap and go on to the next group.
  3. After the last group is processed, we can return how many swaps we have done.
We can scan it at first to record where is each number by saving it into a hash map.
Time Complexity: O(n) + O(n)
Space Complexity: O(n)
Read full article from Minimum number of swaps required for arranging pairs adjacent to each other - GeeksforGeeks

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts